## ros-foxy-maliput-multilane 0.1.5

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_multilane LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(fmt 6.1.2 EXACT REQUIRED)
find_package(maliput REQUIRED)
find_package(maliput_drake REQUIRED)
find_package(yaml-cpp REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

##############################################################################
# Sources
##############################################################################

add_subdirectory(src)
add_subdirectory(resources)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
  ament_doxygen_generate(doxygen_multilane
    CONFIG_OVERLAY doc/Doxyfile.overlay.in
    DEPENDENCIES maliput
    TEST_ON_WARNS
  )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Export
##############################################################################

ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.dsv.in")
ament_environment_hooks("${CMAKE_CURRENT_SOURCE_DIR}/env-hooks/${PROJECT_NAME}.sh.in")

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

ament_export_dependencies(ament_cmake)
ament_export_dependencies(fmt)
ament_export_dependencies(maliput)
ament_export_dependencies(maliput_drake)
ament_export_dependencies(yaml-cpp)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== resources/CMakeLists.txt ===
##############################################################################
# Resources
##############################################################################

set(MULTILANE_RESOURCES
  2x2_intersection.yaml
  branch_and_merge.yaml
  circuit.yaml
  double_ring.yaml
  dual_non_intersecting_lanes.yaml
  fig8.yaml
  helix.yaml
  long_start_and_end_lanes.yaml
  loop.yaml
  multi_branch.yaml
  ring.yaml
  sidewinder.yaml
  tee_intersection.yaml
  village.yaml)

##############################################################################
# Export
##############################################################################

install(
  FILES
    ${MULTILANE_RESOURCES}
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}
)

=== src/CMakeLists.txt ===
add_subdirectory(maliput_multilane)
add_subdirectory(maliput_multilane_test_utilities)
add_subdirectory(plugin)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
      )

      set(MULTILANE_RESOURCE_ROOT ${PROJECT_SOURCE_DIR}/resources/)
      target_compile_definitions(${target}
        PRIVATE
          DEF_MULTILANE_RESOURCE_ROOT="${MULTILANE_RESOURCE_ROOT}"
      )

      target_link_libraries(${target}
          maliput::api
          maliput::common
          maliput::math
          maliput_drake::common
          maliput_multilane::maliput_multilane
          maliput_multilane::test_utilities
      )

    endif()
endmacro()

add_subdirectory(maliput_multilane)
add_subdirectory(maliput_multilane_test_utilities)
add_subdirectory(plugin)

=== src/maliput_multilane/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(MALIPUT_MULTILANE_SOURCES
  arc_road_curve.cc
  branch_point.cc
  builder.cc
  connection.cc
  cubic_polynomial.cc
  junction.cc
  lane.cc
  line_road_curve.cc
  loader.cc
  make_road_curve_for_connection.cc
  multilane_onramp_merge.cc
  road_curve.cc
  road_geometry.cc
  road_network_builder.cc
  segment.cc)

add_library(maliput_multilane ${MALIPUT_MULTILANE_SOURCES})

add_library(maliput_multilane::maliput_multilane ALIAS maliput_multilane)

set_target_properties(maliput_multilane
  PROPERTIES
    OUTPUT_NAME maliput_multilane
)

target_include_directories(maliput_multilane
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(maliput_multilane
  PUBLIC
    maliput::api
    maliput::base
    maliput::geometry_base
    maliput::common
    maliput::math
  PRIVATE
    maliput_drake::analysis
    maliput_drake::common
    maliput_drake::framework
    maliput_drake::math
    maliput_drake::trajectories
    yaml-cpp
)

##############################################################################
# Export
##############################################################################

install(
  TARGETS maliput_multilane
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/maliput_multilane_test_utilities/CMakeLists.txt ===
if(BUILD_TESTING)

find_package(ament_cmake_gmock REQUIRED)
ament_find_gmock()

set(TEST_UTILS_SOURCES
  fixtures.cc
  multilane_types_compare.cc)

add_library(test_utilities ${TEST_UTILS_SOURCES})

add_library(maliput_multilane::test_utilities ALIAS test_utilities)

set_target_properties(test_utilities
  PROPERTIES
    OUTPUT_NAME maliput_multilane_test_utilities
)

target_include_directories(
  test_utilities
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
  PRIVATE
  ${GMOCK_INCLUDE_DIRS}
  )

target_link_libraries(test_utilities
  PUBLIC
    maliput::api
    maliput::common
    maliput::test_utilities
    maliput::math
    maliput_multilane
  PRIVATE
    maliput_drake::analysis
    maliput_drake::common
    maliput_drake::framework
    maliput_drake::math
    maliput_drake::trajectories
)

install(
  TARGETS test_utilities
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

endif()

=== src/plugin/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

### Maliput Multilane Road Network Plugin.
add_library(road_network road_network.cc)
add_library(maliput_multilane::road_network ALIAS road_network)

set_target_properties(road_network
  PROPERTIES
    OUTPUT_NAME maliput_multilane_road_network
)

target_link_libraries(road_network
  maliput::api
  maliput::common
  maliput_multilane::maliput_multilane
)

target_include_directories(road_network
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

### Maliput Multilane On-Ramp Road Network Plugin.
add_library(on_ramp_road_network on_ramp_road_network.cc)
add_library(maliput_multilane::on_ramp_road_network ALIAS on_ramp_road_network)

set_target_properties(on_ramp_road_network
  PROPERTIES
    OUTPUT_NAME maliput_multilane_on_ramp_road_network
)

target_link_libraries(on_ramp_road_network
  maliput::api
  maliput::common
  maliput_multilane::maliput_multilane
)

target_include_directories(on_ramp_road_network
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

##############################################################################
# Export
##############################################################################

# Using a different location as this target is a dynamic library
# which will be loaded in runtime as a maliput plugin.
set(PLUGIN_INSTALL_DIR
    lib/maliput_plugins
)

install(
  TARGETS road_network on_ramp_road_network
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
  RUNTIME DESTINATION bin
)

=== test/maliput_multilane/CMakeLists.txt ===
ament_add_gtest(2x2_intersection_test 2x2_intersection_test.cc)
ament_add_gtest(multilane_arc_road_curve_test multilane_arc_road_curve_test.cc)
ament_add_gtest(multilane_lanes_test multilane_lanes_test.cc)
ament_add_gtest(multilane_line_road_curve_test multilane_line_road_curve_test.cc)
ament_add_gtest(multilane_road_curve_accuracy_test multilane_road_curve_accuracy_test.cc TIMEOUT 120)
ament_add_gtest(multilane_road_geometry_test multilane_road_geometry_test.cc)
ament_add_gtest(multilane_segments_test multilane_segments_test.cc)

ament_add_gmock(multilane_builder_test multilane_builder_test.cc)
ament_add_gmock(multilane_connection_test multilane_connection_test.cc)
ament_add_gmock(multilane_loader_test multilane_loader_test.cc)

add_dependencies_to_test(2x2_intersection_test)
add_dependencies_to_test(multilane_arc_road_curve_test)
add_dependencies_to_test(multilane_builder_test)
add_dependencies_to_test(multilane_connection_test)
add_dependencies_to_test(multilane_lanes_test)
add_dependencies_to_test(multilane_line_road_curve_test)
add_dependencies_to_test(multilane_loader_test)
add_dependencies_to_test(multilane_road_curve_accuracy_test)
add_dependencies_to_test(multilane_road_geometry_test)
add_dependencies_to_test(multilane_segments_test)

=== test/maliput_multilane_test_utilities/CMakeLists.txt ===
ament_add_gtest(fixtures_test fixtures_test.cc)

add_dependencies_to_test(fixtures_test)

=== test/plugin/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

ament_add_gtest(road_network_plugin road_network_plugin_test.cc)
ament_add_gtest(on_ramp_road_network_plugin on_ramp_road_network_plugin_test.cc)

macro(add_dependencies_to_test target)
    if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
      )

      # To avoid a false positive when running ubsan the symbols must be exported
      # See https://stackoverflow.com/questions/57361776/use-ubsan-with-dynamically-loaded-shared-libraries
      set_target_properties(${target}
        PROPERTIES
          ENABLE_EXPORTS ON
      )

      set(MULTILANE_RESOURCE_ROOT ${PROJECT_SOURCE_DIR}/resources/)
      set(ROAD_NETWORK_PLUGIN ${CMAKE_INSTALL_PREFIX}/lib/maliput_plugins/)
      target_compile_definitions(${target}
        PRIVATE
          DEF_MULTILANE_RESOURCE_ROOT="${MULTILANE_RESOURCE_ROOT}"
          DEF_ROAD_NETWORK_PLUGIN="${ROAD_NETWORK_PLUGIN}"
      )

      target_link_libraries(${target}
          maliput_multilane::maliput_multilane
          maliput::common
          maliput::plugin
          # maliput_drake is required because we include maliput_multilane/road_geometry.h to verify
          # the type of the loaded plugin. That requires other types to be imported as well which
          # boils down up to road_curve.h.
          maliput_drake::analysis
          maliput_drake::common
          maliput_drake::framework
          maliput_drake::math
          maliput_drake::trajectories
      )
    endif()
endmacro()

add_dependencies_to_test(road_network_plugin)
add_dependencies_to_test(on_ramp_road_network_plugin)

=== debian/changelog ===
ros-foxy-maliput-multilane (0.1.5-1focal) focal; urgency=high

  * RoadGeometry::FindRoadPositions: Uses maliput-provided base method.  (#101 <https://github.com/maliput/maliput_multilane/issues/101>)
  * Provides plugins for both builders and improves params configuration. (#99 <https://github.com/maliput/maliput_multilane/issues/99>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 13 Apr 2023 03:00:00 -0000

ros-foxy-maliput-multilane (0.1.4-1focal) focal; urgency=high

  * Implements interface for providing default parameters via plugin. (#98 <https://github.com/maliput/maliput_multilane/issues/98>)
  * Updates triage workflow. (#96 <https://github.com/maliput/maliput_multilane/issues/96>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 12 Dec 2022 03:00:00 -0000

ros-foxy-maliput-multilane (0.1.3-1focal) focal; urgency=high

  * Matches with changes in Maliput: Lane::ToLanePosition. (#95 <https://github.com/maliput/maliput_multilane/issues/95>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 14 Sep 2022 03:00:00 -0000

ros-foxy-maliput-multilane (0.1.2-1focal) focal; urgency=high

  * Fixes test utilities (#93 <https://github.com/maliput/maliput_multilane/issues/93>)
  * Adds triage workflow. (#92 <https://github.com/maliput/maliput_multilane/issues/92>)
  * Improves README. (#91 <https://github.com/maliput/maliput_multilane/issues/91>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 29 Jul 2022 03:00:00 -0000

ros-foxy-maliput-multilane (0.1.1-1focal) focal; urgency=high

  * Fixes environment hooks. (#90 <https://github.com/maliput/maliput_multilane/issues/90>)
  * Fixes dependency on environment variables. (#89 <https://github.com/maliput/maliput_multilane/issues/89>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 01 Jul 2022 03:00:00 -0000

ros-foxy-maliput-multilane (0.1.0-1focal) focal; urgency=high

  * Updates package.xml.
  * Suppresses old-rule-api-related warnings. (#88 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/88>)
  * Fixes include folder installation. (#87 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/87>)
  * Relies on compile definitions for testing instead of env vars. (#86 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/86>)
  * Updates license. (#85 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/85>)
  * Uses ament_export_targets. (#84 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/84>)
  * Removes dashing support. (#83 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/83>)
  * Updates IntersectionBook construction points to include the RoadGeometry pointer. (#82 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/82>)
  * Adds BUILD_DOCS flag as opt-in flag (#81 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/81>)
  * Matches with change in maliput's phase ring book loader. (#80 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/80>)
  * Adds workflow_dispatch to other workflows. (#79 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/79>)
  * Adds CI badges (#78 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/78>)
  * Replaces push by workflow_dispatch event in gcc build. (#77 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/77>)
  * Extends RoadNetworkLoader plugin to include yaml descriptions and OnrampMerge implementation. (#76 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/76>)
  * Fixes MALIPUT_PLUGIN_PATH new path. (#75 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/75>)
  * Change install path of the maliput plugin. (#74 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/74>)
  * Use maliput drake (#73 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/73>)
  * Makes multilane to link privately against drake (#72 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/72>)
  * Remove eigen_compare_matrices.h (#71 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/71>)
  * Use maliput math instead of drake (#70 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/70>)
  * Hide drake types part 2 (#69 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/69>)
  * Hide drake types part 1 (#68 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/68>)
  * Enable doxygen verification. (#66 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/66>)
  * Replaces AMENT_CURRENT_PREFIX by COLCON_PREFIX_PATH (#65 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/65>)
  * Removes ament_target_dependencies macro. (#64 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/64>)
  * Set up linker properly when using clang in CI. (#63 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/63>)
  * Remove references to GnuInstallDir vars. (#62 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/62>)
  * rosdep update --include-eol-distros (#61 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/61>)
  * Enable CI for 20.04 (#60 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/60>)
  * Foxy style fix part 2: reorder includes (#59 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/59>)
  * pybind11 is not needed in CI (#58 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/58>)
  * Foxy include style part 1: use <> for maliput, drake headers (#57 <https://github.com/ToyotaResearchInstitute/maliput_multilane/issues/57>)


=== debian/control ===
Source: ros-foxy-maliput-multilane
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libyaml-cpp-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-maliput, ros-foxy-maliput-drake, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-multilane
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libyaml-cpp-dev, ros-foxy-maliput, ros-foxy-maliput-drake, ros-foxy-ros-workspace
Description: Maliput Multilane.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-multilane//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
